import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.io.PrintStream;
import java.io.OutputStream;

/**
 * The world where all the finch's demo components are stored.
 *
 * This class is based on the original 2010 FinchWorld by Michael Berry
 */
public class FinchWorld  extends World
{
    private Finch finch;

    public FinchWorld()
    {
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 400, 1);
        prepare();
    }

    /**
     * Manage the sliders.
     */
    public void act() {

    }

    /**
     * Start the finch when the scenario starts. Don't remove this!!
     */
    @Override
    public void started() {
        startFinch();
    }

    /**
     * Stops the finch when the scenario stops. Don't remove this!!
     */
    @Override
    public void stopped() {
        stopFinch();
    }

    /**
     * Prepare the world for the start of the program. That is: create the initial
     * objects and add them to the world.
     */
    private void prepare()
    {
        
    }

    /**
     * Start the finch.
     */
    private void startFinch() {
        System.out.print("Connecting...");
        stopFinch();
        PrintStream ps = System.out;
        System.setOut(new PrintStream(new OutputStream(){public void write(int b){}}));
        finch = new Finch();
        System.setOut(ps);
        System.out.println("Done");
    }

    /**
     * Stop the finch.
     */
    private void stopFinch() {
        if(finch != null) {
            System.out.print("Stopping...");
            finch.stopAll();
            finch.disconnect();
            System.out.println("Done");
            finch = null;
        }
    }

    /**
     * Get the current finch object.
     * @return the raw finch object.
     */
    public Finch getFinch() {
        if(finch==null) {
            startFinch();
        }
        return finch;
    }
}
